// Copyright 2022 Bitcoding

import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:google_applovin_unity_ads/google_applovin_unity_ads.dart';

class MainScreen extends StatefulWidget {
  const MainScreen({Key? key}) : super(key: key);

  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MainScreen> {
  Widget _bannerAd = Container(height: 0);
  final List<Widget> _nativeAds = [];
  final itemCount = 200;
  final nativeAdDistance = 5;

  final String placeholderText =
      """
      
      Hello This example screen is second screen.
     
      """;

  @override
  void initState() {
    super.initState();
    loadAdsinList();
    loadBannerAds(
        size: AdSize.leaderboard,
        onAdLoadedCallback: (bannerAds) => {
          setState(() {
            _bannerAd = showBannerAds(banner:bannerAds, size: AdSize.leaderboard);
          })
        });

  }

  @override
  void dispose() {
    super.dispose();
    destroyAd();
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Builder(builder: (BuildContext context) {
        return Scaffold(
          appBar: AppBar(
            title: const Text('Ads example app'),
            actions: <Widget>[
              PopupMenuButton<String>(
                onSelected: (String result) {
                  switch (result) {
                    case 'InterstitialAd':
                      showIntraAds(
                          callback: () => {print("Show Completed true")});
                      break;
                    case 'RewardedAd':
                      showRewardAds(
                          callback: () => {print("Show Completed true")});
                      break;
                    default:
                      throw AssertionError('unexpected button: $result');
                  }
                },
                itemBuilder: (BuildContext context) => <PopupMenuEntry<String>>[
                  const PopupMenuItem<String>(
                    value: 'InterstitialAd',
                    child: Text('InterstitialAd'),
                  ),
                  const PopupMenuItem<String>(
                    value: 'RewardedAd',
                    child: Text('RewardedAd'),
                  )
                ],
              ),
            ],
          ),
          body: SafeArea(child: ListView.separated(
            itemCount: itemCount,
            itemBuilder: (context, index) {
              return ListTile(
                title: Text(placeholderText),
              );
            },
            separatorBuilder: (context, index) {
              if (index % nativeAdDistance == 0) {
                final adsIndex = index~/nativeAdDistance;
                /*
                if ( adsIndex % 4 == 0) {
                  loadNativeAds(
                      onAdLoadedCallback: (nativeAds) => {
                        setState(() {
                          _nativeAds[adsIndex] = (showNativeAds(nativeAd:nativeAds));
                        })
                      }
                  );
                } else {
                  loadBannerAds(
                      onAdLoadedCallback: (bannerAds) => {
                        setState(() {
                          _nativeAds[adsIndex] = (showBannerAds(banner:bannerAds));
                        })
                      }
                  );
                }
                return _nativeAds[adsIndex];*/

                return showBannerAdsGrid(
                   size: adsIndex % 3 == 0 ? AdSize.leaderboard : ( adsIndex % 5 == 0 ? AdSize.mediumRectangle : (adsIndex % 7 == 0 ? AdSize.fullBanner : AdSize.banner))
                );
              }

              return Container(height: 0);
            },
          )),
          bottomNavigationBar: _bannerAd,
        );
      }),
    );
  }

  loadAdsinList() {
    for (var i = 0; i < itemCount~/nativeAdDistance; i++) {
      _nativeAds.add(Container(height: 0,));
    }
  }
}
